/*
 * PointGrouper.java
 *
 * Created on November 5, 2002, 3:37 PM
 */

package edu.jhu.cer.CollisionGroup;

import java.util.Stack;
import java.util.Vector;

/**
 *
 * @author  gjastrab
 */
public class PointGrouper
{
    public double start, end, max;
    public Stack groupStack, finalStack;
    private int groupCount;
    
    /** Creates a new instance of PointGrouper */
    public PointGrouper(double s, double e, double m)
    {
        start = s;
        end = e;
        max = m;
        finalStack = new Stack(); // use this stack as final output stack
        groupStack = new Stack(); // use stack to put groups on in order, then the lastly made groups
        groupCount = 0;
    }
    
    public boolean isOverlapping(double date1, double date2)
    {
        double x1 = ((date1 - start) / (end - start)) * max;
        double x2 = ((date2 - start) / (end - start)) * max;
        if(Math.abs(x1 - x2) < 80) return true;
        else return false;
    }
    
    public void processGStack() // outputs contents of groupStack to finalStack, assigning 
    {
        TLPoint tempP;
        Group tempG = new Group(start, end, max);
        boolean groupFound = false;
        while(!groupStack.isEmpty())
        {
            tempP = (TLPoint)groupStack.remove(0);
            if(groupStack.isEmpty())
            {
                if(groupFound)
                {
                    groupCount++;
                    tempG.addPoint(tempP);
                    tempG.setID(groupCount);
                    finalStack.push((Group)tempG.clone());
                    tempG.clear();
                    groupFound = false;
                }
                else
                {
                    tempG.addPoint(tempP);
                    groupCount++;
                    tempG.setID(groupCount);
                    finalStack.push((Group)tempG.clone());
                    tempG.clear();
                }
                break;
            }
            if(groupStack.get(0) == "*")
            {
                groupStack.remove(0);
                if(groupFound)
                {
                    groupCount++;
                    tempG.addPoint(tempP);
                    tempG.setID(groupCount);
                    finalStack.push((Group)tempG.clone());
                    tempG.clear();
                    groupFound = false;
                }
                else finalStack.push(tempP);
            }
            else
            {
                tempG.addPoint(tempP);
                groupFound = true;
                if(groupStack.isEmpty())
                {
                    groupCount++;
                    tempG.setID(groupCount);
                    Group groupClone = (Group)tempG.clone();
                    finalStack.push(groupClone);
                    tempG.clear();
                }
            }
        }
    }
}
