/*
 * TLPoint.java
 *
 * Created on November 1, 2002, 1:50 PM
 */

package edu.jhu.cer.CollisionGroup;

import java.util.Vector;

/**
 *
 * @author  gjastrab
 */
public class TLPoint implements Cloneable
{
	private double myDate;
	private Vector overlapsWith;
	private boolean canBeAlone, isGrouped;      // may not even need these variables
	private TLPoint prev, next;
	
	public TLPoint(double d)
	{
            myDate = d;
            overlapsWith = new Vector();
            canBeAlone = true;
            isGrouped = false;
            prev = null;
            next = null;
	}
        
        //constructor for clone() method
        public TLPoint(double d, Vector v, boolean c, boolean i, TLPoint p, TLPoint n)
        {
            myDate = d;
            overlapsWith = v;
            canBeAlone = c;
            isGrouped = i;
            prev = p;
            next = n;
        }
	
        public Object clone() //overwrites clone method in order to copy a Group object
        {
            return new TLPoint(this.myDate, this.overlapsWith, this.canBeAlone, this.isGrouped, this.prev, this.next);
        }
        
        public double getDate() { return myDate; }
        
	public void addClash(TLPoint p)
	{
            overlapsWith.add(p);
            canBeAlone = false;
            isGrouped = true;
	}
        
        public void removeClash(TLPoint p)
        {
            overlapsWith.remove(p);
            if(overlapsWith.isEmpty())
            {
                canBeAlone = true;
                isGrouped = false;
            }
        }
	
        public boolean isOverlapping(TLPoint p) { return overlapsWith.contains(p); }
        
        public boolean beAlone() { return canBeAlone; }
        public boolean grouped() { return isGrouped; }
        
        public void setPrev(TLPoint p) { prev = p; }
        public void setNext(TLPoint p) { next = p; }
	public TLPoint getPrev() { return prev; }
	public TLPoint getNext() { return next; }
}
