package edu.jhu.cer.General;

import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;

public class GenericErrorWindow extends JDialog {
	JLabel  msgLabel;
	JButton okButton;
	
    // this window needs to be able to grow to fit the size of the text message
    // a new layout would be good too.

	public GenericErrorWindow(String title, String message) {
	    setModal(true);
	    setSize(400,185);
		setLocation(145,200);
		setResizable(false);
		setTitle(title);

		// load the warning icon
		ClassLoader cl1 = getClass().getClassLoader();
		ImageIcon warnIcon = new ImageIcon(cl1.getResource("metal-Warn.gif"));

		// create the message
		msgLabel = new JLabel(message, SwingConstants.CENTER);
		msgLabel.setAlignmentX(Component.CENTER_ALIGNMENT);	

		// OK button stuff
		okButton = new JButton("OK");
		okButton.setAlignmentX(Component.CENTER_ALIGNMENT);

		okButton.createToolTip();

		okButton.setToolTipText("Dismiss Window");
		okButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				dispose();
			}
		}
		);		
		
		// create a panel for the warning icon
		JPanel iconPanel = new JPanel();
		JLabel iconLabel = new JLabel(warnIcon);

		iconPanel.setLayout(new BoxLayout(iconPanel, BoxLayout.Y_AXIS));
		iconPanel.add(iconLabel);

		// create the warning message panel
		JPanel messagePanel = new JPanel();
		messagePanel.setLayout(new BoxLayout(messagePanel, BoxLayout.X_AXIS));
		messagePanel.add(msgLabel);

		// create the okButton panel
		JPanel buttonsPanel = new JPanel();
		
		buttonsPanel.setLayout(new BoxLayout(buttonsPanel, BoxLayout.X_AXIS));
		buttonsPanel.add(okButton);
		
		// create the righthand panel
		JPanel rightSide = new JPanel();
		rightSide.setLayout(new BoxLayout(rightSide, BoxLayout.Y_AXIS));
		rightSide.add(messagePanel);
		rightSide.add(buttonsPanel);

		// create the content pane
		Container contentPane = getContentPane();

		// split the warning window horizontally
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.X_AXIS));

		contentPane.add(Box.createRigidArea(new Dimension(5, 10)));
		contentPane.add(iconPanel);
		contentPane.add(Box.createRigidArea(new Dimension(10, 0)));
		contentPane.add(rightSide);
	}
}
