package edu.jhu.cer.TimelineCreator;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import java.lang.ClassLoader;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.SwingConstants;
import javax.swing.JOptionPane;
import java.awt.BorderLayout;

/**
 * Brings up the about menu within the GUI.
 */

class AboutMenuHandler implements ActionListener {
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    public AboutMenuHandler(TimelineCreator timeline) {
	tlc = timeline;
    }

    /**
     * Extends actionPerformed method from ActionEvent handler to open a JPanel containing
     * information about the Timeline project.
     */
    public void actionPerformed (ActionEvent ae){
	ClassLoader cl = getClass().getClassLoader();
	ImageIcon icon = new ImageIcon(cl.getResource("images/logo.jpg"));
	JPanel myPanel = new JPanel();
	JLabel aboutLabel = new JLabel("<html><b><font size = \"+2\" color=\"red\">Timeline Creator Version 2.0</font></b><br><font size=\"-2\">&copy;Copyright Center for Educational Resources, Johns Hopkins University, 2006.</font><br><br><h2><font color=\"blue\">Center for Education Resources</font></h2><font size = \"+1\">Team Members:</font><br><B>Greg Jastrab</B><br><b>David Lefcourt</b><br><b>Arun Nagarajan</b><br><B>Mike Reese</B><br><b>Roy Hodgman</b><br><b>Benny Tsai</b><br><b>Nick Gauthier</b><br><B>Joshua Liu</B><br><B>Reid Sczerba</B><br></html>");
	JButton linkButton = new JButton("<html><font size=\"-1\"><a href=\"http://timeline.cer.jhu.edu\">http://timeline.cer.jhu.edu</a></font></html>");
	linkButton.setHorizontalAlignment(SwingConstants.LEFT);
	linkButton.setBorderPainted(false);
	linkButton.addActionListener(new AboutLink());
	myPanel.setLayout(new BorderLayout());
	myPanel.add("North",aboutLabel);
	myPanel.add("South",linkButton);
	JOptionPane.showMessageDialog(tlc ,myPanel, "About Timeline Creator",JOptionPane.INFORMATION_MESSAGE,icon);
    }
}
