package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Adds a new event to the JTable in the TimelineCreator Object
 * which stores all the events.
 */
class AddNewEvent implements ActionListener {
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    public AddNewEvent(TimelineCreator timeline) {
	tlc = timeline;
    }	
    /**
     * Extending the actionPerfomred method from an ActionListener, this method
     * extracts the data from the UI that has been entered in the DetailPane
     * and puts that into a new row in the Event table in the TimelineCreator
     * object.
     */
    public void actionPerformed(ActionEvent ae) {
	String title1 = tlc.title1TF.getText();
	String start = tlc.startTF.getText();
	String end = tlc.endTF.getText();
	String description = tlc.descriptionTA.getText();
        // This code is inserted because bandCB now contains the names of the
        // bands via an update
	String band = "sub"+tlc.bandCB.getSelectedIndex();
	if (tlc.bandCB.getSelectedIndex() == 0) band = "main";
	String icon = tlc.iconCB.getSelectedItem().toString();
	String detail = tlc.detailCheckB.isSelected() ? "Yes" : "No";
	String detailText1 = tlc.detailText1TF.getText();
	String detailText2 = tlc.detailText2TF.getText();
	String detailText3 = tlc.detailText3TF.getText();
	String detailText4 = tlc.detailText4TF.getText();
	String detailImagefile1 = tlc.detailImage1TF.getText();
	String detailImagefile2 = tlc.detailImage2TF.getText();
	String detailImagefile3 = tlc.detailImage3TF.getText();
	String detailImagefile4 = tlc.detailImage4TF.getText();
	String show = tlc.hideCheckB.isSelected() ? "Yes" : "No";
	String mainImagefile = tlc.detailImageBG.getSelection().getActionCommand();
	
       
	// String icon = myIcon.substring(11,myIcon.indexOf("."));

	Object[] newData = {title1,start, end, band, icon, detail,detailText1,detailText2, detailText3, detailText4,detailImagefile1,detailImagefile2,detailImagefile3,detailImagefile4, description,show,mainImagefile};
	tlc.dtm.addRow(newData);
	//sets field to null    
	tlc.title1TF.setText("");
	tlc.startTF.setText("");
	tlc.endTF.setText("");
	tlc.descriptionTA.setText("");
	tlc.bandCB.setSelectedIndex(0);
	tlc.iconCB.setSelectedIndex(9);
	tlc.detailText1TF.setText("");
	tlc.detailText2TF.setText("");
	tlc.detailText3TF.setText("");
	tlc.detailText4TF.setText("");
	tlc.detailImage1TF.setText("");
	tlc.detailImage2TF.setText("");
	tlc.detailImage3TF.setText("");
	tlc.detailImage4TF.setText("");
	tlc.detailCheckB.setSelected(false);
	tlc.hideCheckB.setSelected(false);
	tlc.detailImage1RB.setSelected(true);
      
	tlc.dataTabbedPane.setSelectedIndex(0);
    } 
}
