package edu.jhu.cer.TimelineCreator;

import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

/**
 * A renderer used primarily to draw Icons.
 */

class ComboBoxRenderer extends JLabel implements ListCellRenderer {
    /**
     * Sets the box to opaque, the horizontal alignment to left
     * and the vertical alignment to center.
     */
    public ComboBoxRenderer() {
	setOpaque(true);
	setHorizontalAlignment(LEFT);
	setVerticalAlignment(CENTER);
    }

    /**
     * Creates a JLabel with an icon on it for use in the TimelineCreator.
     */
    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
	if (isSelected) {
	    setBackground(list.getSelectionBackground());
	    setForeground(list.getSelectionForeground());
	} else {
	    setBackground(list.getBackground());
	    setForeground(list.getForeground());
	}

	ImageIcon icon = (ImageIcon)value;
	setText(icon.getDescription());
	setIcon(icon);
	return this;
    }
}
