package edu.jhu.cer.TimelineCreator;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Class to remove event row from table.
 */
class DeleteEvent implements ActionListener {
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    public DeleteEvent(TimelineCreator timeline, JTable table) {
	tlc = timeline;
	jt = table;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	int rownum = jt.getSelectedRow();
	((DefaultTableModel)jt.getModel()).removeRow(rownum);
	if (rownum == jt.getRowCount()) {rownum--;}
	if (rownum >= 0) {
	    jt.setRowSelectionInterval(rownum,rownum);
	}
    } 
}
