package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;
//import java.awt.image.ImageFilter; our own ImageFilter is defined
import java.io.File;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * Browsing function when opening a file or selecting an image.
 */
class DetailBrowse implements ActionListener{
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    int id;    

    public DetailBrowse(TimelineCreator timeline) {
	tlc = timeline;
	id = 1;
    }

    public DetailBrowse(TimelineCreator timeline, int id_in) {
	tlc = timeline;
	id = id_in;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae){
	JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
	fc.addChoosableFileFilter(new MediaFilter());
	fc.addChoosableFileFilter(new ImageFilter());
	fc.addChoosableFileFilter(new AudioFilter());
	fc.addChoosableFileFilter(new VideoFilter());
	fc.setFileView(new ImageFileView());
	fc.setFileFilter(new MediaFilter());
	fc.setAccessory(new ImagePreview(fc));

	int returnVal = fc.showDialog(tlc, "Pick");

	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    File file = fc.getSelectedFile();
	    String path = file.getPath();
	    path = toRelativePath(System.getProperty("user.dir"),path);
	    if ( id == 1)
		tlc.detailImage1TF.setText(path);
	    else if ( id == 2 )
		tlc.detailImage2TF.setText(path);
	    else if ( id == 3 )
		tlc.detailImage3TF.setText(path);
	    else if ( id == 4 )
		tlc.detailImage4TF.setText(path);
	} 
    }
	
    /**
     * Converts input path and outputs relative path.
     *
     * @param from source folder
     *        to destination folder
     * @return String of the relative path of the 'from' to the 'to' path
     */
    public String toRelativePath(String from,String to){
	Vector fromVector = new Vector();
	Vector toVector = new Vector();
	String output = new String("");
	String delimiter = System.getProperty("file.separator");
	boolean sameDrive = false;
    
	StringTokenizer fromSt = new StringTokenizer(from,delimiter);
	while(fromSt.hasMoreTokens()) {
	    fromVector.addElement(fromSt.nextToken());
	}

	StringTokenizer toSt = new StringTokenizer(to,delimiter);
	while(toSt.hasMoreTokens()) {
	    toVector.addElement(toSt.nextToken());
	} 	
  
	if (!(toVector.elementAt(0).toString().equals(fromVector.elementAt(0).toString()))){sameDrive = true;}
  
	while(!(toVector.isEmpty() || fromVector.isEmpty())){
	    if (!(toVector.elementAt(0).toString().equals(fromVector.elementAt(0).toString()))){
		break;	
	    }		
	    fromVector.remove(0);
	    toVector.remove(0);
	}
  
	if(!sameDrive){
	    for(int i = 0;i<fromVector.size();i++){
		output+= ".." + delimiter;
	    }
	}

	for(int j = 0;j<toVector.size()-1;j++){
	    output += toVector.elementAt(j).toString() + delimiter;
	}
	output += toVector.elementAt(toVector.size()-1).toString();
  	output = output.replace('\\','/');
	return output;
    }  	
	
	
}
