package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;
import javax.swing.JTable;
import java.io.FileWriter;
import java.io.IOException;
/**
 * Class function to output data without XML tags to text file.
 */
class ExportMenuHandler implements ActionListener {
    /**
     * A reference to the main {@link TimelineCreator} object, which gets
     * used when we want to bring up a warning window.
     */
    TimelineCreator creator;

    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;

    /**
     * Sets up class variables.
     * @param tc The parent {@link TimelineCreator} object
     * @param table The table storing all event data
     */
    public ExportMenuHandler(TimelineCreator tc, JTable table) {
	creator = tc;
	jt = table;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	JFileChooser jfc = new JFileChooser();
	int choice = jfc.showSaveDialog(creator);
	if (choice == JFileChooser.APPROVE_OPTION) {
	    String filename = jfc.getSelectedFile().getAbsolutePath();

	    try {
		FileWriter fw = new FileWriter(filename);
		int rows = jt.getRowCount() - 1;
		int cols = jt.getColumnCount() - 1 ;
		String export = "";
		
		for(int i = 0;i <= rows; i++) {
		    for(int j = 0; j<=12; j++){
			if (jt.getValueAt(i,j) != null){
			    export += jt.getValueAt(i,j); 
			}
			export += "\t";
		    }
		    export += "\n";
		}
		
		fw.write(export);
		fw.flush();
	    } catch (IOException ioe) {};
      		
	} 

    }

}
