package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JTable;
import javax.swing.JTabbedPane;

/**
 * Class to take user to first event in table.
 */
class FirstEvent implements ActionListener {
    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;

    /**
     * The tabbed pane used to popup a message dialog.
     */
    JTabbedPane mtp;

    /**
     * Sets up class variables.
     * @param table The table storing all event data
     * @see #mtp mtp
     */
    public FirstEvent(JTable table, JTabbedPane jtp) {
	jt = table;
	mtp = jtp;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	if (jt.getSelectedRow() == 0) {ShowError.showDialog(mtp, "You are already on the first Event");}
	jt.setRowSelectionInterval(0,0);
	jt.scrollRectToVisible(jt.getCellRect(0,0,true));
    } 
}
