package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.io.IOException;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 * Import feature to opn file, go line by line, and break values by (tab)
 */
class ImportMenuHandler implements ActionListener {
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;
    
    /**
     * The table model used to add rows to the table.
     */
    DefaultTableModel  dtm;

    /**
     * Stores a reference to the timeline creator, table, and main tabbed pane. 
     * @see #tlc tlc
     * @see #jt jt
     */
    public ImportMenuHandler(TimelineCreator creator, JTable table, DefaultTableModel tmodel) {
	tlc = creator;
	jt = table;
	dtm = tmodel;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	JFileChooser jfc = new JFileChooser();
	int returnVal = jfc.showOpenDialog(tlc);
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	    String filename = jfc.getSelectedFile().getAbsolutePath();
	    String delimiter;
	    try{
		BufferedReader in = new BufferedReader(new FileReader(filename));
		if (filename.endsWith(".csv")){delimiter = ",";}
		else {delimiter = "\t";}
		String line;
		int row = 0;
		Object emptydata[] = {};  	
		while((line = in.readLine()) != null){
		    int col = 0;
		    dtm.addRow(emptydata);
					
		    Object[] ra = new Object[]{};
		    ArrayList al = new ArrayList();
		    StringTokenizer st = new StringTokenizer(line,delimiter);
		    while(st.hasMoreTokens()){
			al.add(st.nextToken());
		    }
		    ra = al.toArray();
					
		    //String[] ra = line.split(delimiter); //1.4 specific
		    for (int i=0;i<ra.length;i++){
			//jt.setValueAt(ra[i],row,col);
			jt.setValueAt(ra[i].toString(),row,col);
			col++;
		    }
		    row++;
		}
		in.close();
	    }
	    catch(IOException e){
		System.out.println(e.getMessage());
	    }
	}
    }
}
