package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JTable;
import javax.swing.JTabbedPane;

/**
 * Class to take user to last even in table.
 */
class LastEvent implements ActionListener {
    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;
    
    /**
     * The tabbed pane used to popup a message dialog.
     */
    JTabbedPane mtp;
    
    /**
     * Sets up class variables.
     * @param table The table storing all event data
     * @see #mtp mtp
     */
    public LastEvent(JTable table, JTabbedPane jtp) {
	jt = table;
	mtp = jtp;
    }
    
    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
		if (jt.getSelectedRow() == jt.getRowCount()-1) {
				ShowError.showDialog(mtp,"You are already on the last Event");
			}
		else if ( jt.getRowCount()-1 >= 0 ){
				jt.setRowSelectionInterval(jt.getRowCount()-1,jt.getRowCount()-1);
				jt.scrollRectToVisible(jt.getCellRect(jt.getRowCount()-1,0,true));
			}
    } 
}
