package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JTable;
import javax.swing.JTabbedPane;

/**
 * Class to take user to next evevt in table.
 */
class NextEvent implements ActionListener {
    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;

    /**
     * The tabbed pane used to popup a message dialog.
     */
    JTabbedPane mtp;

    /**
     * Sets up class variables.
     * @param table The table storing all event data
     * @see #mtp mtp
     */
    public NextEvent(JTable table, JTabbedPane pane) {
	jt = table;
	mtp = pane;
    }
	
    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	if (jt.getSelectedRow() == jt.getRowCount()-1) {ShowError.showDialog(mtp,"You are already on the last Event");}
	int rownum = jt.getSelectedRow();
	//System.out.println("Currenly on " + rownum + " out of " + jt.getRowCount());
	if (rownum < jt.getRowCount()-1) {rownum++;}
	jt.setRowSelectionInterval(rownum,rownum);
	jt.scrollRectToVisible(jt.getCellRect(rownum,0,true));
    } 
}
