package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JTable;

/**
 * Class to take user to previous event in table.
 */
class PreviousEvent implements ActionListener {
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    public PreviousEvent(TimelineCreator timeline, JTable table) {
	tlc = timeline;
	jt = table;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	if (jt.getSelectedRow() == 0) {ShowError.showDialog(tlc.mainTabbedPane,"You are already on the first Event");}
	int rownum = jt.getSelectedRow();
	//System.out.println("Currenly on " + rownum);
	if (rownum > 0) {rownum--;}
	jt.setRowSelectionInterval(rownum,rownum);
	jt.scrollRectToVisible(jt.getCellRect(rownum,0,true));
    } 
}
