package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JTabbedPane;

/**
 * Checks to see that there has been no updates made to the timeline
 * since the last time it was saved, then quits. If there have been changes,
 * it opens up a warning window to alert the user and asks if they wouold like
 * to save the changes.
 */
class QuitMenuHandler implements ActionListener {
    /**
     * A reference to the main {@link TimelineCreator} object, which gets
     * used when we want to bring up a warning window.
     */
    TimelineCreator tlc;

    /**
     * Stores a reference to the main tabbed pane. 
     * @see #mainTabbedPane mainTabbedPane
     */
    public QuitMenuHandler(TimelineCreator creator) {
	tlc = creator;
    }

    /**
     * If there has been a changet to the table or any info on the timeline
     * this brings up a window asking if the user wants to save changes.
     */
    public void actionPerformed(ActionEvent ae) {
	if(IsTableEdited.tableChanged){
	    JLabel myLabel = new JLabel("<html>You have not saved the current project. Unsaved changes will be lost.<br> Do you want to save the changes before exiting?</html>");
  		
	    JOptionPane pane = new JOptionPane(myLabel,JOptionPane.QUESTION_MESSAGE,JOptionPane.YES_NO_CANCEL_OPTION);
	    JDialog dialog = pane.createDialog(tlc, "Unsaved Project");
	    dialog.show();
	    int value = ((Integer)pane.getValue()).intValue();
		 if (value == JOptionPane.YES_OPTION) {
			SaveMenuHandler smh = new SaveMenuHandler(tlc);
			//inelegant way to call the save menu
			smh.actionPerformed(ae);
	    }
	    if (value == JOptionPane.NO_OPTION) {
			System.exit(0);
	    }
	}
	else{System.exit(0);}
    } 
}
