package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JTable;

/**
 * Class to allow user to make a change to existing event in table.
 */
class ReplaceEvent implements ActionListener {
    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * The table used to store all the event data back in the {@link TimelineCreator}.
     */
    JTable jt;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    public ReplaceEvent(TimelineCreator timeline, JTable table) {
	tlc = timeline;
	jt = table;
    }

    /**
     * Public method for class.
     */
    public void actionPerformed(ActionEvent ae) {
	int id = jt.getSelectedRow();
        if(id != -1) {
            jt.setValueAt(tlc.title1TF.getText(),id,0);
            jt.setValueAt(tlc.startTF.getText(),id,1);
            jt.setValueAt(tlc.endTF.getText(),id,2);
            jt.setValueAt(tlc.descriptionTA.getText(),id,14);
	    // This code is inserted because bandCB now contains the names of the
	    // bands via an update
	    String bandName = "sub"+tlc.bandCB.getSelectedIndex();
	    if (tlc.bandCB.getSelectedIndex() == 0) bandName = "main";
            jt.setValueAt(bandName,id,3);
	    
            jt.setValueAt(tlc.detailText1TF.getText(),id,6);
            jt.setValueAt(tlc.detailText2TF.getText(),id,7);
            jt.setValueAt(tlc.detailText3TF.getText(),id,8);
            jt.setValueAt(tlc.detailText4TF.getText(),id,9);
            jt.setValueAt(tlc.detailImage1TF.getText(),id,10);
            jt.setValueAt(tlc.detailImage2TF.getText(),id,11);
            jt.setValueAt(tlc.detailImage3TF.getText(),id,12);
            jt.setValueAt(tlc.detailImage4TF.getText(),id,13);
            String icon = tlc.iconCB.getSelectedItem().toString();
            jt.setValueAt(icon,id,4);
            String show1 = tlc.detailCheckB.isSelected() ? "Yes" : "No";
            jt.setValueAt(show1,id,5);
            String show2 = tlc.hideCheckB.isSelected() ? "Yes" : "No";
            jt.setValueAt(show2,id,15);
            jt.setValueAt(tlc.detailImageBG.getSelection().getActionCommand(),id,16);
        }
        
        
	tlc.title1TF.setText("");
	tlc.startTF.setText("");
	tlc.endTF.setText("");
	tlc.descriptionTA.setText("");
	tlc.bandCB.setSelectedIndex(0);
	tlc.iconCB.setSelectedIndex(9);
	tlc.detailText1TF.setText("");
	tlc.detailText2TF.setText("");
	tlc.detailText3TF.setText("");
	tlc.detailText4TF.setText("");
	tlc.detailImage1TF.setText("");
	tlc.detailImage2TF.setText("");
	tlc.detailImage3TF.setText("");
	tlc.detailImage4TF.setText("");
	tlc.detailCheckB.setSelected(false);
	tlc.hideCheckB.setSelected(false);
	tlc.detailImage1RB.setSelected(true);
        
	jt.clearSelection();
        
	tlc.dataTabbedPane.setSelectedIndex(0);

    } 
}
