package edu.jhu.cer.TimelineCreator;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.ClassLoader;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

/**
 * Frame class for saving before a preview.
 */
class SaveBeforePreviewFrame extends JDialog{
    JLabel msgLabel;
    JButton cancelButton,saveButton;

    /**
     * The main timeline creator window.
     */
    TimelineCreator tlc;

    /**
     * Saves a reference to the main timeline creator.
     * @see #tlc tlc
     */
    public SaveBeforePreviewFrame(TimelineCreator timeline) {
	tlc = timeline;
    }

    /**
     * Public method for class.
     */
    public SaveBeforePreviewFrame(){
	setModal(true);
	setSize(400,135);
	setLocation(145,200);
	setResizable(false);
	setTitle("File not saved");
	
	ClassLoader cl1 = getClass().getClassLoader();
	ImageIcon warnIcon = new ImageIcon(cl1.getResource("images/metal-Warn.gif"));
		
				
	msgLabel = new JLabel("<html>Please save the changes before previewing. <br>Click on cancel to continue working with events or <br>click save to proceed with saving.",
			      warnIcon,
			      SwingConstants.CENTER);
	msgLabel.setAlignmentX(Component.CENTER_ALIGNMENT);	

	cancelButton = new JButton("Cancel");
	cancelButton.setAlignmentX(Component.CENTER_ALIGNMENT);

	cancelButton.createToolTip();

	cancelButton.setToolTipText("Cancel this window and go back to edit event data");
	cancelButton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    dispose();
		}
	    }
				       );		

	saveButton = new JButton("Save");
	saveButton.setAlignmentX(Component.CENTER_ALIGNMENT);

	saveButton.createToolTip();
	saveButton.setToolTipText("Save changes now");
	saveButton.addActionListener(new SaveMenuHandler(tlc));
	saveButton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    dispose();
		}
	    }
				     );		
	JPanel buttonsPanel = new JPanel();
		
	buttonsPanel.setLayout(new BoxLayout(buttonsPanel, BoxLayout.X_AXIS));
	buttonsPanel.add(cancelButton);
	buttonsPanel.add(saveButton);
		
	Container contentPane = getContentPane();
		
	contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
	contentPane.add(Box.createRigidArea(new Dimension(5, 10)));
	contentPane.add(msgLabel);
	contentPane.add(Box.createRigidArea(new Dimension(10, 0)));
	contentPane.add(buttonsPanel);
    }
}
