package edu.jhu.cer.TimelineCreator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JTabbedPane;
import java.awt.Dimension;

/**
 * Enable/disable bottom navigation buttons
 */
class ViewMenuHandler implements ActionListener {
    /**
     * A reference to the main {@link TimelineCreator} object, which gets
     * used when we want to bring up a warning window.
     */
    TimelineCreator tlc;

    /**
     * Stores a reference to the main tabbed pane. 
     * @see #mainTabbedPane mainTabbedPane
     */
    public ViewMenuHandler(TimelineCreator creator) {
	tlc = creator;
    }

    /**
     * If there has been a changet to the table or any info on the timeline
     * this brings up a window asking if the user wants to save changes.
     */
    public void actionPerformed(ActionEvent ae) {
		if(tlc.prevButton.isVisible()) {
			
			tlc.prevButton.setVisible(false);
			tlc.nextButton.setVisible(false);
			tlc.firstButton.setVisible(false);
			tlc.lastButton.setVisible(false);
			//tlc.dataEditPanel.setPreferredSize(new Dimension(520, 395));
			//tlc.dataEditPanel.setMinimumSize(new Dimension(520, 395));
			//tlc.dataEditPanel.setMaximumSize(new Dimension(520, 395));
		}
		else{
			tlc.prevButton.setVisible(true);
			tlc.nextButton.setVisible(true);
			tlc.firstButton.setVisible(true);
			tlc.lastButton.setVisible(true);
			//tlc.dataEditPanel.setPreferredSize(new Dimension(520, 420));
			//tlc.dataEditPanel.setMinimumSize(new Dimension(520, 420));
			//tlc.dataEditPanel.setMaximumSize(new Dimension(520, 420));
		}

    } 
}
